<template>
  <AppAbstractPage
    :breadcrumbs="breadcrumbs"
    class="pageContractPart">
    <div
      slot="heading"
      class="pageHeading">
      <h1 class="heading _h1">
        {{ metaTitle }}
      </h1>
    </div>

    <div
      slot="content"
      class="contractPart grid-content">

      <div class="contractPart-name area-name">
        <div
          v-if="isPrivateSeller"
          class="sellerPrivate">Частное объявление</div>
        <h1 class="heading _h3">
          {{ metaTitle }}
        </h1>
      </div>

      <div
        class="contractPart-slider area-slider"
        v-if="images().length">
        <template
          v-if="!isMobile()">
          <div class="contractPart-images">
            <Carousel
              class="_vertical"
              :entities="images('small')"
              :items-to-show="4"
              :items-to-slide="1"
              :vertical="true"
              :controls-class="'_transparent'"
              :has-pagination="true"
              @slide="onSetCurrentImage($event.currentSlide)">
              <div
                slot="entity"
                slot-scope="{ entity, index }"
                class="contractPart-image">
                <img
                  @click="onSetCurrentImage(index)"
                  :src="entity.url"
                  :alt="entity.alt">
              </div>

              <img
                slot="prev"
                svg-inline
                src="~/assets/svg/redesign/carousel-arrow.svg">
              <img
                slot="next"
                svg-inline
                src="~/assets/svg/redesign/carousel-arrow.svg">
            </Carousel>
          </div>
          <div class="contractPart-currentImage">
            <img
              :src="images('big')[currentImage].url"
              :alt="images('big')[currentImage].alt"
              @click="onOpenLightBox(); $ym('enlarge_photo')">
          </div>
        </template>

        <template v-else>
          <Carousel
            :entities="images()"
            :items-to-show="1"
            :items-to-slide="1"
            :controls-class="'_double'"
            :has-pagination="true">
            <div
              slot="entity"
              slot-scope="{ entity }"
              class="contractPart-image">
              <img
                @click="onOpenLightBox(); $ym('enlarge_photo')"
                :src="entity.url"
                :alt="entity.alt">
            </div>

            <img
              slot="prev"
              svg-inline
              src="~/assets/svg/redesign/carousel-double-arrow.svg">
            <img
              slot="next"
              svg-inline
              src="~/assets/svg/redesign/carousel-double-arrow.svg">
          </Carousel>
        </template>
      </div>

      <div
        v-else
        class="contractPart-slider area-slider">
        <div class="noPhoto">
          <img
            svg-inline
            src="~/assets/svg/redesign/navigation-parts.svg">
        </div>
      </div>

      <div class="contractPart-relevance area-relevance">
        <div class="value">Объявление №&nbsp;{{ id }}</div>
        <div
          class="value __no-wrap"
          v-if="status === ref.PartStatus.STATUS_ACTIVE">
          <!--     TODO: Когда будут просмотры тогда вернуть -->
          <!-- <span class="_width-separator">{{ actualAt.seconds | dateFormat({ nouns: true, time: true }) }}</span>-->
          Дата публикации: {{ actualAt.seconds | dateFormat({ nouns: true, time: true }) }}
          <!--     TODO: Просмотров нет еще   -->
          <!--          <span>1 142  просмотра</span>-->
        </div>
        <div
          class="value"
          v-if="status === ref.PartStatus.STATUS_ARCHIVED">
          <!--     TODO: Когда будут просмотры тогда вернуть -->
          <!-- <span class="_width-separator">{{ actualAt.seconds | dateFormat({ nouns: true, time: true }) }}</span>-->
          Помещено в архив: {{ statusUpdatedAt.seconds | dateFormat({ nouns: true, time: true }) }}
          <!--     TODO: Просмотров нет еще   -->
          <!--          <span>1 142  просмотра</span>-->
        </div>
        <div
          class="value"
          v-if="status === ref.PartStatus.STATUS_DELETED">
          <!--     TODO: Когда будут просмотры тогда вернуть -->
          <!-- <span class="_width-separator">{{ actualAt.seconds | dateFormat({ nouns: true, time: true }) }}</span>-->
          Удалено: {{ statusUpdatedAt.seconds | dateFormat({ nouns: true, time: true }) }}
          <!--     TODO: Просмотров нет еще   -->
          <!--          <span>1 142  просмотра</span>-->
        </div>
      </div>

      <div class="contractPart-price area-price">
        <AppSellerPrice :price="round(cost)"/>
      </div>

      <div class="contractPart-characteristics area-characteristics">
        <div
          v-if="isPrivateSeller"
          class="sellerPrivate">Частное объявление</div>
        <!--     TODO: Нужна модель описывающая характеристики {характеристику}   -->
        <!--     TODO: Нужен цикл выводящий такие сущности  -->
        <AppAccordion>
          <template #panel-title>Характеристики</template>
          <template #content>
            <div class="boxFeature">
              <h2 class="boxFeature-title">Характеристики</h2>
              <ul class="boxFeature-list">
                <li
                  class="boxFeature-list-item"
                  v-if="getCondition(characteristics)">
                  <div class="boxFeature-list-name">
                    <span>Состояние</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ getCondition(characteristics) }}
                  </span>
                </li>
                <li
                  class="boxFeature-list-item"
                  v-if="characteristics.quantity">
                  <div class="boxFeature-list-name">
                    <span>Количество</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ characteristics.quantity }} шт.
                  </span>
                </li>
                <li
                  class="boxFeature-list-item"
                  v-if="formattedDelivery">
                  <div class="boxFeature-list-name">
                    <span>Наличие/Срок поставки</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ formattedDelivery }}
                  </span>
                </li>
                <li
                  class="boxFeature-list-item"
                  v-if="characteristics.carManufacturer">
                  <div class="boxFeature-list-name">
                    <span>Марка автомобиля</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ characteristics.carManufacturer.name }}
                  </span>
                </li>
                <li
                  class="boxFeature-list-item"
                  v-if="characteristics.carModel">
                  <div class="boxFeature-list-name">
                    <span>Модель автомобиля</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ characteristics.carModel.name }}
                  </span>
                </li>
                <li
                  class="boxFeature-list-item"
                  v-if="characteristics.color">
                  <div class="boxFeature-list-name">
                    <span>Цвет</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ characteristics.color }}
                  </span>
                </li>
                <li
                  class="boxFeature-list-item"
                  v-if="characteristics.carChassis">
                  <div class="boxFeature-list-name">
                    <span>Кузов</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ characteristics.carChassis }}
                  </span>
                </li>
                <li
                  class="boxFeature-list-item"
                  v-if="characteristics.carEngine">
                  <div class="boxFeature-list-name">
                    <span>Двигатель</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ characteristics.carEngine }}
                  </span>
                </li>
                <li
                  class="boxFeature-list-item"
                  v-if="characteristics.carYears">
                  <div class="boxFeature-list-name">
                    <span>Год</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ characteristics.carYears }}
                  </span>
                </li>
                <li
                  class="boxFeature-list-item"
                  v-if="characteristics.vendorCode">
                  <div class="boxFeature-list-name">
                    <span>Артикул</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ characteristics.vendorCode }}
                  </span>
                </li>
                <li
                  class="boxFeature-list-item"
                  v-if="characteristics.partManufacturer">
                  <div class="boxFeature-list-name">
                    <span>Производитель детали</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ characteristics.partManufacturer.brand }}
                  </span>
                </li>
                <li
                  class="boxFeature-list-item"
                  v-if="formattedPlacement">
                  <div class="boxFeature-list-name">
                    <span>Стороны установки</span>
                  </div>
                  <span class="boxFeature-list-value">
                    {{ formattedPlacement }}
                  </span>
                </li>
              </ul>
            </div>
          </template>
        </AppAccordion>
      </div>

      <div class="contractPart-seller-info-first area-seller-info-first">
        <div class="sellerActions">
          <ButtonPhones
            v-if="isPrivateSeller"
            class="buttonCallPrivateSeller"
            :phones="[phonePrivateSeller]"
            @call="onShowPhone"/>
          <ButtonPhones
            v-else
            :phones="phoneNonePrivateSeller"
            @call="onShowPhone"/>
          <div class="paragraph">
            <span>Скажите продавцу, что нашли</span>
            <span class="__no-wrap">это предложение на ГисАвто</span>
          </div>
          <AppWidgetChat
            v-if="shopId && !isSameUser(this)"
            type="contractPart"
            :id="id"
            :params="{shopId}"
            @click.native="onClickChat"/>
        </div>
      </div>

      <div class="contractPart-seller-info-last area-seller-info-last">
        <div class="sellerBasic">
          <!--<flink
            v-if="!isPrivateSeller"
            href="#"
            target="_blank"
            class="linkIsMobile">
            <img
              svg-inline
              src="~/assets/svg/redesign/button-arrow-right.svg">
          </flink>-->
          <template v-if="isPrivateSeller">
            <div class="sellerBasic-item __bold">
              <span v-if="user.userProfile.firstName">
                Продавец:&nbsp;&nbsp;{{ user.userProfile.firstName }}
              </span>
            </div>
          </template>
          <template v-else>
            <!--<div class="sellerBasic-item">
                        <AppRating :current-rating="3.5"/>
                        <span class="sellerBasic-reviews">
                          <template v-if="true">
                            {{ 13 }}
                            {{ 13 | transChoose(['отзыв', 'отзыва', 'отзывов']) }}
                          </template>
                        </span>
                      </div>-->
            <div class="sellerBasic-item __bold">
              <span>Магазин:&nbsp;&nbsp;</span>
              <img
                v-if="shop.shopData.contact_is_confirmed"
                svg-inline
                src="~/assets/svg/redesign/ok-small-blue.svg">
              <flink
                :href="`/seller/${shopId}/${shop.organization.id}`"
                @click.native="onViewShopCard"
                target="_blank"
                class="link">
                {{ shop.shopData.shop_name }}
              </flink>
            </div>
          </template>
          <div class="sellerBasic-item">
            <AppButton
              v-if="!isShowEmail"
              :classes="['buttonAsLink', '_transparent']"
              @click.native="onClickShowEmail(); $ym('kz_show_email')">
              <template #button-item>Показать e-mail</template>
            </AppButton>
            <flink
              v-show="isShowEmail"
              :href="`mailto:${email}`"
              target="_blank"
              class="link">
              {{ email }}
            </flink>
          </div>
        </div>
        <div class="boxFeature">
          <template v-if="additionalContacts.length">
            <div class="boxFeature-title">
              Связаться с продавцом
            </div>
            <AppSocial
              :contacts="additionalContacts"
              @clicked="onMessengerClick"/>
          </template>
          <AppButton
            v-if="!isPrivateSeller"
            class="buttonAsLink buttonReport"
            @click.native="onClickCreateAbuse(); $ym('kz_abuse_open')">
            <template #button-item>
              <img
                svg-inline
                src="~/assets/svg/redesign/attention-fill.svg">
              Пожаловаться на объявление
            </template>
          </AppButton>
        </div>
      </div>
      <!--    TODO: Этого функционала нет-->
      <div
        class="contractPart-buttons-order area-buttons-order"
        v-if="false">
        <div
          class="buttonsOrder"
          v-if="true">
          <AppButton
            :classes="['buttonOutlineColor', 'buttonOrder']">
            <template #button-item>Быстрый заказ</template>
          </AppButton>
          <AppButton :classes="['buttonCart']">
            <span
              slot="button-item"
              class="button-item">
              <img
                svg-inline
                src="~/assets/svg/redesign/basket-full.svg">
              В корзину
            </span>
          </AppButton>
        </div>
        <div
          class="value"
          v-else>
          Это ваш товар
        </div>
      </div>

      <div class="contractPart-map area-map">
        <div
          class="sellerAddress"
          v-if="address">
          <span class="sellerAddress-title">Адрес:</span>
          <span class="value">{{ address }}</span>
          <img
            svg-inline
            src="~/assets/svg/redesign/button-arrow-right.svg">
          <AppButton
            v-if="!isPrivateSeller"
            :classes="['buttonOutline', 'buttonShowMap']"
            @click.native="onOpenMap">
            <template #button-item>
              {{ !isMapExpanded ? 'Показать на карте' : 'Скрыть карту' }}
            </template>
          </AppButton>
        </div>

        <div
          class="sellerMap"
          :class="{ '-expanded': isMapExpanded }">
          <button
            class="buttonBack"
            @click="onOpenMap">
            <img
              svg-inline
              src="~/assets/svg/redesign/arrow-left-bold.svg">
          </button>
          <AppAbstractMap
            v-if="isMapExpanded"
            :placemarks="[placemark]"
            :init-coords="placemark"
            :with-balloon="true"
            :balloon-configuration="$options.balloonConfiguration"
            :hint-configuration="$options.hintConfiguration"
            :zoom="16">
            <template
              v-slot:balloon="{
                markerId,
                balloonEntity,
                balloonPosition,
                balloonDirection,
                balloonConfiguration,
                balloonOpened,
                closeBalloon }">
              <AppMapPopupBalloon
                :marker-id="markerId"
                :balloon-entity="balloonEntity"
                :balloon-position="balloonPosition"
                :balloon-direction="balloonDirection"
                :balloon-configuration="balloonConfiguration"
                :balloon-opened="balloonOpened"
                :class="{'__hidden': !balloonOpened}"
                @close-balloon="closeBalloon"
                @click-fast-order="onFastOrder(markerId)"
              />
            </template>
          </AppAbstractMap>
        </div>
      </div>

      <div
        class="contractPart-description area-description"
        v-if="description">
        <h2 class="contractPart-title">Описание</h2>
        <AppAccordion>
          <template #panel-title>Описание</template>
          <template #content>
            <div class="paragraph">
              {{ description }}
            </div>
          </template>
        </AppAccordion>
      </div>

      <div class="contractPart-share area-share">
        <div class="heading _h3">Поделиться</div>
        <ShareLinkSocial/>
      </div>


      <div class="contractPart-report area-report">
        <AppButton
          v-if="!isPrivateSeller"
          :classes="['buttonOutline', 'buttonReport']"
          @click.native="onClickCreateAbuse(); $ym('kz_abuse_open')">
          <template #button-item>Пожаловаться на объявление</template>
        </AppButton>
      </div>

      <footer
        v-if="!isMobile()"
        class="area-footer">
        <AppRecommendations
          v-if="recommendData.data.length"
          :url="recommendUrl"
          :heading="recommendTitle"
          :recommendations="recommendData.data"/>
      </footer>

      <AppModalAbuse
        v-scroll-lock="hasAbuse"
        :shop-id="seller.id"
        :seller-title="seller.title"
        :visible="!isPrivateSeller && hasAbuse"
        @before-close="hasAbuse = false"/>
      <no-ssr>
        <vue-easy-lightbox
          v-dom-move
          :visible="isLightBox"
          :imgs="currentImages"
          :index="currentImage"
          @hide="onCloseLightBox"
        />
      </no-ssr>
    </div>
  </AppAbstractPage>
</template>

<script>
import { has, get } from 'lodash-es';
import { ItemStatus as PartStatus, Placement } from '~/assets/js/enums/contract-parts-grpc';
import Placemark from '~/assets/js/enums/placemark';

import AppAbstractPage from '~/components/redesign/layout/app-abstract-page';
import AppSearch from '~/components/redesign/app-search/app-search';
import AppSelect from '~/components/redesign/app-select/app-select';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppSellerPrice from '~/components/redesign/seller/app-seller-price';
import AppRating from '~/components/redesign/app-rating';
import AppWidgetChat from '~/components/redesign/widget/app-widget-chat';
import AppSocial from '~/components/redesign/app-social';
import AppButtonCall from '~/components/redesign/app-buttons/app-button-call';
import AppAccordion from '~/components/redesign/app-accordion';
import AppAbstractMap from '~/components/redesign/app-map/app-abstract-map';
import AppMapBalloon from '~/components/redesign/app-map/app-map-balloon';
import AppMapHint from '~/components/redesign/app-map/app-map-hint';
import AppRecommendations from '~/components/redesign/app-recommendations/app-recommendations';
import AppModalAbuse from '~/components/redesign/app-modals/app-modal-abuse';
import Carousel from '~/components/redesign/carousel';
import ShareLinkSocial from '~/components/blocks/share-link-social';

import ContractPart from '~/assets/js/mixins/contract-part';
import SeoMixin from '~/assets/js/mixins/seo/base';
import SeoPageMixin from '~/assets/js/mixins/seo/pages/main/do/part/id';
import RouteParamsPrefixMapping from '~/assets/js/model/do/route-params-prefixes';
import mapFilters from '~/assets/js/helpers/map-filters';
import isMobileMixin from '~/assets/js/mixins/is-mobile';
import ButtonPhones from '../../../../components/redesign/app-buttons/buttonPhones';
import AppMapPopupBalloon from '~/components/redesign/app-map/app-map-popup-balloon';

export default {
  name: 'DoPartItem',
  components: {
    ButtonPhones,
    AppAccordion,
    AppButtonCall,
    AppSocial,
    AppWidgetChat,
    AppRating,
    AppSellerPrice,
    AppButton,
    AppAbstractPage,
    AppSearch,
    AppSelect,
    AppAbstractMap,
    AppMapBalloon,
    AppMapHint,
    AppRecommendations,
    AppModalAbuse,
    Carousel,
    ShareLinkSocial,
    AppMapPopupBalloon,
  },
  mixins: [ContractPart, SeoMixin, SeoPageMixin, isMobileMixin],
  validate({ params }) {
    return /^\d+$/.test(params.id);
  },
  async asyncData({ app, params, error }) {
    try {
      const { data } = { ...await app.$axios.$get('/_main/contractParts/get', { params: { id: params.id } }) };
      if (!data) {
        throw new Error('no data');
      }

      const recommendCriteria = {
        criteria: {
          carManufacturer: data.expertCarManufacturerId,
          carModel: data.expertCarModelId,
          city: data.geoId,
          excludeIdsList: [data.id],
        },
        order: {
          field: null,
          direction: null,
        },
        limit: 4,
      };
      const { data: recommendData } = {
        ...await app.$axios.$get('/_main/contractParts/list', { params: recommendCriteria }),
      };
      // TODO: Improve создать сущность seller
      // const isPrivateSeller = !data.shop && data.user && !data.user.isOrganization && data.user.userProfile;
      // const seller = {
      //   isPrivateSeller,
      //   name: isPrivateSeller ? data.user.userProfile.firstName : data.shop.shopData.shop_name,
      //   phones: isPrivateSeller ? data.user.userProfile.phone : data.shop.shopData.phones,
      //   email: isPrivateSeller ? data.user.username : data.shop.shopData.email_exists,
      //   id: isPrivateSeller ? '' : data.shopId,
      //   additionalContacts: isPrivateSeller ? [] : data.shop.shopData.additional_contacts,
      //   city: isPrivateSeller ? data.user.userProfile.city.name : data.shop.shopData.city_name,
      //   street: isPrivateSeller ? '' : data.shop.shopData.street,
      //   building: isPrivateSeller ? '' : data.shop.shopData.building,
      // };

      return { ...data, recommendData };
    } catch (e) {
      console.error(e);
      if (get(e, 'response.data.error.errorCode', null) === 404) {
        error({ statusCode: 404 });
      } else {
        error({ statusCode: 500 });
      }
    }

    return {};
  },
  data() {
    return {
      isMapExpanded: false,
      ref: {
        PartStatus,
      },
      photoCurrent: 0,
      isContactsVisible: false,
      currentImages: [],
      isLightBox: false,
      isShowEmail: false,
      hasAbuse: false,
      statSent: {
        email: false,
        phone: false,
      },
      currentImage: 0,
      isShowPhone: false,
    };
  },
  computed: {
    breadcrumbs() {
      return [
        {
          url: '/do/part',
          name: 'Контрактные запчасти',
        },
        {
          url: '',
          name: `Объявление № ${this.id}`,
        },
      ];
    },
    metaTitle() {
      const metaTitle = [`Продам ${this.sellerPartName(this.title)}`];
      if (
        has(this.carManufacturer, 'name')
        && has(this.carModel, 'name')
      ) {
        metaTitle.push(`для ${this.carManufacturer.name} ${this.carModel.name}`);
      }
      if (has(this.formattedCarYears, 'value')) {
        metaTitle.push(`${this.formattedCarYears.value} ${this.formattedCarYears.noun}`);
      }
      metaTitle.push(`в ${this.geo.prepositionalName}`);
      return metaTitle.join(' ');
    },
    isPrivateSeller() {
      return !this.shop && this.user && !this.user.isOrganization && this.user.userProfile;
    },
    placemark() {
      return this.isPrivateSeller
        ? {}
        : {
          ...this.shop,
          shopId: this.shopId,
          cost: this.round(this.cost),
          organizationId: this.shop.organization.id,
          coord_lat: this.shop.shopData.lat,
          coord_lng: this.shop.shopData.lng,
        };
    },
    phonePrivateSeller() {
      return get(this.user, 'userProfile.phone', '');
    },
    phoneNonePrivateSeller() {
      return get(this.shop, 'shopData.phones', []);
    },
    additionalContacts() {
      if (this.shop) {
        return get(this.shop, 'shopData.additional_contacts', []);
      }
      if (this.user) {
        return [];
      }

      return [];
    },
    email() {
      if (this.shop) {
        return get(this.shop, 'shopData.email_exists', null);
      }
      if (this.user) {
        return this.user.username;
      }
      return null;
    },
    address() {
      return this.isPrivateSeller
        ? this.getAddressPrivateSeller()
        : this.getAddressNonePrivateSeller();
    },
    characteristics() {
      return {
        condition: this.condition,
        quantity: this.quantity,
        color: this.color,
        vendorCode: this.vendorCode,
        carManufacturer: this.carManufacturer,
        carModel: this.carModel,
        carChassis: Array.isArray(this.chassisList) && this.chassisList.length
          ? this.chassisList.join(', ')
          : this.carChassis,
        carEngine: Array.isArray(this.enginesList) && this.enginesList.length
          ? this.enginesList.join(', ')
          : this.carEngine,
        carYears: get(this.formattedCarYears, 'value', false),
        partManufacturer: this.partManufacturer,
        placement: this.placementList,
        inStock: this.inStock,
        deliveryTime: this.deliveryTime,
      };
    },
    photoAvailability() {
      return this.imagesList && this.imagesList.length ? 'есть фото' : 'без фото';
    },
    formattedCarYears() {
      const yearStart = get(this.carYears, 'start.year', false);
      const yearEnd = get(this.carYears, 'end.year', false);
      let result = null;

      if (yearStart && yearEnd) {
        if (yearStart === yearEnd) {
          result = {
            value: yearStart,
            noun: 'года',
          };
        } else {
          result = {
            value: `${yearStart}-${yearEnd}`,
            noun: 'годов',
          };
        }
      }
      return result;
    },
    formattedPlacement() {
      const getPlacementName = (placement) => {
        switch (placement) {
          case Placement.PLACEMENT_FRONT:
            return 'Перед';
          case Placement.PLACEMENT_REAR:
            return 'Зад';
          case Placement.PLACEMENT_LEFT:
            return 'Лево';
          case Placement.PLACEMENT_RIGHT:
            return 'Право';
          case Placement.PLACEMENT_TOP:
            return 'Верх';
          case Placement.PLACEMENT_BOTTOM:
            return 'Низ';
          default:
            return false;
        }
      };

      return [
        this.characteristics.placement
          .filter(placement => placement === Placement.PLACEMENT_FRONT || placement === Placement.PLACEMENT_REAR)
          .map(getPlacementName)
          .filter(Boolean)
          .join('/'),
        this.characteristics.placement
          .filter(placement => placement === Placement.PLACEMENT_TOP || placement === Placement.PLACEMENT_BOTTOM)
          .map(getPlacementName)
          .filter(Boolean)
          .join('/'),
        this.characteristics.placement
          .filter(placement => placement === Placement.PLACEMENT_LEFT || placement === Placement.PLACEMENT_RIGHT)
          .map(getPlacementName)
          .filter(Boolean)
          .join('/'),
      ].filter(Boolean).join(', ');
    },
    formattedDelivery() {
      if (this.characteristics.inStock) {
        return 'в наличии';
      }
      if (/^\d+$/.test(this.characteristics.deliveryTime) && Number(this.characteristics.deliveryTime) !== 0) {
        return [
          this.characteristics.deliveryTime,
          this.transChoose(this.characteristics.deliveryTime, ['день', 'дня', 'дней']),
        ].join(' ');
      }
      return null;
    },
    recommendTitle() {
      return `Другие запчасти для ${this.carManufacturer.name} ${this.carModel.name} в ${this.geo.prepositionalName}`;
    },
    recommendUrl() {
      const params = {};
      params.city = `${RouteParamsPrefixMapping.city}${this.geo.slug}`;
      params.carManufacturer = `${RouteParamsPrefixMapping.carManufacturer}${this.carManufacturer.slug}`;
      params.carModel = `${RouteParamsPrefixMapping.carModel}${this.carModel.slug}`;
      return this.$router.resolve({ name: 'do-part', params }).href;
    },
    statData() {
      return {
        adId: this.id,
        adName: this.title,
        userId: this.userId,
        shopId: this.shopId,
        geoId: this.geoId,
        brandId: this.carManufacturer.id,
        brandName: this.carManufacturer.name,
        modelId: this.carModel.id,
        modelName: this.carModel.name,
        chassis: this.chassisList,
        engines: this.enginesList,
        years: [get(this.carYears, 'start.year', 0), get(this.carYears, 'end.year', 0)],
      };
    },
    seller() {
      return {
        id: !this.isPrivateSeller ? this.shopId : null,
        title: !this.isPrivateSeller ? this.shop.shopData.shop_name : '',
      };
    },
  },
  created() {
    this.$options.balloonConfiguration = {
      template: AppMapBalloon,
      type: Placemark.SELLER,
    };
    this.$options.hintConfiguration = {
      template: AppMapHint,
      type: Placemark.SELLER,
    };
  },
  mounted() {
    this.$statDo('view-ad', this.statData);
  },
  methods: {
    ...mapFilters(['dateFormat', 'round', 'transChoose', 'sellerPartName']),
    images(size = 'small') {
      if (!this.imagesList || !this.imagesList.length) {
        return [];
      }

      return this.imagesList.map((image, index, { length }) => {
        let url = image[`${size}Uri`];

        if (!url) {
          return null;
        }

        url = this.$config.imagesBaseUrl + url;

        let alt = this.title;

        if (length > 1) {
          alt += `, фото ${index + 1}`;
        }

        return {
          url,
          alt,
        };
      }).filter(i => Boolean(i));
    },
    onShowPhone() {
      if (this.statSent.phone) {
        return;
      }

      this.isShowPhone = true;

      this.$ym('show_contacts');
      this.$statDo('view-phone', this.statData);
      this.statSent.phone = true;
    },
    onClickShowEmail() {
      if (this.statSent.email) {
        return;
      }

      this.isShowEmail = true;
      this.$ym('show_contacts');
      this.$statDo('view-email', this.statData);
      this.statSent.email = true;
    },
    onClickCreateAbuse() {
      this.hasAbuse = true;
    },
    onClickChat() {
      this.$statDo('click-chat', this.statData);
    },
    onMessengerClick() {
      this.$statDo('view-messenger', this.statData);
    },
    onViewShopCard() {
      this.$ym('more_about_the_store');
      this.$statDo('view-shop-card', this.statData);
    },
    onOpenMap() {
      this.isMapExpanded = !this.isMapExpanded;
      this.$ym('show_map');
      this.$statDo('view-map', this.statData);
    },
    getAddressPrivateSeller() {
      return this.user.userProfile.city && this.user.userProfile.city.name;
    },
    getAddressNonePrivateSeller() {
      const result = [];
      get(this.shop, 'shopData.city_name', false) && result.push(this.getLocation({
        geo: this.geo,
        metro: this.metro,
      }));
      get(this.shop, 'shopData.street', false) && result.push(`ул. ${this.shop.shopData.street}`);
      get(this.shop, 'shopData.building', false) && result.push(`д. ${this.shop.shopData.building}`);
      return result.join(', ');
    },
    onSetCurrentImage(index) {
      this.currentImage = index;
    },
    onOpenLightBox() {
      this.currentImages = this.images('extra').map(image => image.url);
      this.isLightBox = true;
    },
    onCloseLightBox() {
      this.isLightBox = false;
    },
  },
};

</script>

<style lang="postcss">
  /* Стили для блоков с инфой о продавце */
  @import '~/assets/css/components/seller-info.css';

  /* autoprefixer: off */
  .pageContractPart {
    .pageHeading {
      @media screen and (max-width: 980px) {
        display: none;
      }
    }

    .grid-content {
      display: grid;

      .area-slider {
        grid-area: slider;
      }

      .area-name {
        grid-area: name;
      }

      .area-relevance {
        grid-area: relevance;
      // background-color: rgba(255,196,66,0.25);
      }

      .area-price {
        grid-area: price;
      // background-color: rgba(222,222,222,0.25);
      }

      .area-characteristics {
        grid-area: characteristics;
      // background-color: rgba(51,117,187,0.25);
      }

      .area-seller-info-first {
        grid-area: seller-info-first;
      }

      .area-seller-info-last {
        grid-area: seller-info-last;
      }

      .area-buttons-order {
        grid-area: buttons-order;
      }

      .area-map {
        grid-area: map;
      }

      .area-description {
        grid-area: description;
      }

      .area-report {
        grid-area: report;
      }

      .area-share {
        grid-area: share;
      }

      .area-footer {
        grid-area: footer;
      }

      @media screen and (min-width: 981px) {
        grid-template-columns: 28.75rem 1fr 18.75rem;
        grid-auto-rows: auto auto auto 1fr auto auto auto auto auto;
        grid-template-areas:
          "slider relevance price"
          "slider characteristics price"
          "slider characteristics seller-info-first"
          "slider characteristics seller-info-last"
          "slider characteristics buttons-order"
          "map map map"
          "description description description"
          "share share share"
          "footer footer footer";

        .area-name, .area-report {
          display: none;
        }

        &._no-image {
          grid-template-columns: 60rem 18.75rem;
          grid-template-areas:
            "relevance price" "characteristics seller-info-first"
            "characteristics seller-info-last" "characteristics buttons-order"
            "map map" "description description";

          .area-slider {
            display: none;
          }
        }
      }

      @media (min-width: 981px) and (max-width: 1200px) {
        grid-template-columns: 22.125rem 1fr 18.125rem;
      }

      @media screen and (max-width: 980px) {
        margin-top: -1rem;
        padding: 0 1.25rem;
        grid-template-columns: 100%;
        grid-template-areas: "relevance" "slider" "name" "price" "seller-info-first"
        "characteristics" "description" "map" "seller-info-last" "buttons-order" "report";

        &._no-image {
          .area-slider {
            display: none;
          }
        }
      }
    }

    .contractPart {
      padding-bottom: 4rem;

      &-title {
        display: block;
        margin: 0;
        padding: 0;
        font-size: 1.125rem;
        font-weight: var(--font-weight-medium);
      }

      &-relevance {
        display: flex;
        justify-content: space-between;
        align-items: flex-start;

        .value {
          display: inline-flex;
          font-size: 0.75rem;
          color: var(--color-main-lightest);
        }
      }

      &-price {
        .sellerPrice {
          font-size: 1.5rem;
          &-item {
            font-weight: var(--font-weight-extra-bold);
          }
          &-old {
            padding-left: 2.5rem;
          }
          .discount {
            margin-bottom: -0.5rem;
            .svg {
              width: 1.6875rem;
              height: auto;
            }
          }
        }
      }

      &-characteristics {
        .boxFeature {
          &-title {
            margin: 0;
            padding: 0;
            font-size: 1.125rem;
            font-weight: var(--font-weight-medium);
          }
          &-list {
            display: block;
            font-size: 0.75rem;
            &-item {
              display: flex;
              align-items: flex-end;
              padding: 0.5rem 0 0;

            }
            &-name {
              padding-right: 0.5rem;
              width: 60%;
              font-weight: var(--font-weight-medium);
              border-bottom: 1px dashed var(--border-color-light);
              > span {
                margin-bottom: -2px;
                padding-bottom: 2px;
                background-color: var(--bg-main);
              }
            }
            &-value {
              width: 40%;
              margin-bottom: 1px;
              color: var(--color-main-lightest);
              background-color: var(--bg-main);
            }
          }
        }
      }

      &-map {
        display: block;
        margin-top: 1.5rem;
        padding: 0.5rem 1.25rem;
        font-size: 0.875rem;
        border-top-left-radius: 0.25rem;
        border-top-right-radius: 0.25rem;
        border-bottom: 1px solid var(--border-color-main);

        .appAbstractMap,
        .ymap-container {
          height: inherit;
        }

        .buttonShowMap {
          margin: 0 1rem;
          min-height: var(--btn-height-small);
          font-size: 0.75rem;
          font-weight: var(--font-weight-regular);
        }
      }

      &-share {
        display: flex;
        flex-direction: row;
        justify-content: flex-start;
        align-items: center;
        padding: 1rem 0 0;
        @media only screen and ( max-width: 980px ) {
          display: none;
        }

        .title {
          font-weight: var(--font-weight-bold);
        }
      }

      &-buttons-order {
        .buttonsOrder {
          display: flex;
          width: 100%;

          .button + .button {
            margin-left: 0.75rem;
          }

          .button-item {
            display: flex;
            align-items: center;
          }

          .svgBasket {
            margin-top: -0.25rem;
            margin-right: 0.5rem;
            width: 1.125rem;
            height: auto;
          }
        }
      }

      @media screen and (min-width: 981px) {
        &-slider {
          display: flex;
          max-height: 100%;

          .noPhoto {
            display: flex;
            justify-content: center;
            align-items: center;
            width: 100%;
            height: 100%;
            background-color: var(--bg-lightest);

            .svg {
              width: 5rem;
              height: auto;
              fill: var(--fill-light);
            }
          }

          .contractPart-image {
            flex-shrink: 0;
            display: block;
            width: 100%;
            height: 4.25rem;
            background-color: var(--bg-main);
            border:  1px solid var(--border-color-main);
          }

          .contractPart-images {
            flex-shrink: 0;
            width: 4.25rem;
            margin-right: 1.5rem;

            & > .carousel {
              height: 100%;
            }
          }

          .contractPart-currentImage {
            display: block;
            width: 100%;
            max-width: 23rem;
            max-height: 100%;
            min-height: 21rem;
            border: 1px solid var(--border-color-main);

            & > img {
              display: block;
              height: 100%;
              width: 100%;
              object-fit: contain;
            }
          }
        }

        &-relevance {
          margin: 0 1.875rem;
          min-height: 2rem;
          border-bottom: 1px solid var(--border-color-main);
          .value {
            align-items: flex-start;
            padding-bottom: 0.5rem;
            ._width-separator {
              display: inline-flex;
              margin-right: 0.75rem;
              padding-right: 0.75rem;
              border-right: 1px solid var(--color-disabled);
            }
            &:first-of-type {
              padding-right: 1rem;
            }
          }
        }

        &-seller-info-first {
          display: block;
          padding: 1rem 1.25rem 0 1.25rem;
          background: var(--bg-main);
          border: 1px solid var(--border-color-light);
          border-bottom: none;
          box-shadow: 0 2px 2px rgba(0, 0, 0, 0.1);
          border-top-left-radius: 0.25rem;
          border-top-right-radius: 0.25rem;

          & .buttonCallPrivateSeller,
          .buttonPhones,
          .appWidgetChat {
            width: 100%;
          }

          .appWidgetChat {
            margin-bottom: 1rem;
            & .buttonChat {
              .svg.cloud {
                display: block;
              }
            }
          }

          .paragraph {
            display: block;
            padding-top: 0.5rem;
            padding-bottom: 0.5rem;
            font-size: 0.75rem;
            text-align: center;
          }
        }

        &-seller-info-last {
          display: flex;
          flex-direction: column;
          padding: 0 1.25rem;
          background: var(--bg-main);
          border: 1px solid var(--border-color-light);
          border-top: none;
          box-shadow: 0 2px 2px rgba(0, 0, 0, 0.1);
          border-bottom-left-radius: 0.25rem;
          border-bottom-right-radius: 0.25rem;

          .sellerBasic {
            padding-bottom: 1rem;
            &-item {
              display: flex;
              align-items: flex-start;
            }

            .buttonAsLink {
              font-size: inherit;
              font-weight: var(--font-weight-bold);
            }

            .linkIsMobile {
              display: none;
            }
          }

          .boxFeature {
            display: block;
            margin: auto -1.25rem 0;
            padding: 0.5rem 1.25rem 0.5rem 1.25rem;
            font-size: 0.75rem;
            background-color: var(--bg-dark);

            &-title {
              font-weight: var(--font-weight-bold);
            }
          }

          .sclContacts {
            flex-wrap: wrap;
            padding-top: 0.5rem;
            &-item {
              margin-bottom: 0.75rem;
            }
          }
        }

        &-price {
          .AppSellerPrice {
            align-items: flex-start;
            margin-top: -0.5rem;
          }
        }

        &-characteristics {
          display: flex;
          flex-direction: column;
          margin: 1rem 1.875rem;
          .sellerPrivate {
            margin: -0.75rem 0 0 auto;
          }
        }

        &-buttons-order {
          padding: 1.25rem 0;

          .buttonCart,
          .buttonOrder {
            padding: 0 0.25rem;
            width: 100%;
            height: var(--btn-height-medium);
            font-size: 0.75rem;
          }
        }

        &-map {
          background-color: var(--bg-dark);

          .svg {
            display: none;
          }

          .sellerAddress {
            &-title {
              padding-right: 0.5rem;
              font-weight: var(--font-weight-medium);
            }
          }

          .sellerMap {
            height: 0;
            opacity: 0;
            transition: height 0.3s var(--transition-easeOutQuad), opacity 0.2s var(--transition-easeOutQuad);

            &-title {
              font-weight: var(--font-weight-bold);
            }

            &.-expanded {
              margin: 0.75rem 0 0.375rem;
              height: 27.5rem;
              opacity: 1;
            }

            .buttonBack {
              display: none;
            }
          }
        }

        &-description {
          padding: 1rem 0;
          border-bottom: 1px solid var(--border-color-main);

          .paragraph {
            padding-top: 0.5rem;
          }
        }

        &-report {
          padding: 1.25rem 1.25rem 3rem;
        }

        .buttonReport {
          display: flex;
          padding: 0;
          margin-left: auto;
          width: auto;
          height: 1.25rem;
          font-size: .6875rem;
          font-weight: var(--font-weight-regular);
          white-space: nowrap;
          >.svg {
            margin-right: .25rem;
            margin-bottom: 1px;
            width: 0.75rem;
            height: 0.75rem;
          }
        }

        .AppRecommendations {
          padding-top: 1rem;
        }
      }

      @media (min-width: 981px) and (max-width: 1200px) {
        &-slider {
          .contractPart-images {
            width: 3.625rem;
            margin-right: 0.5rem;
          }
          .contractPart-image {
            height:  3.625rem;
          }
        }

        &-seller-info-first {
          padding: 1rem 1rem 0;
          .sellerActions {
            display: flex;
            flex-wrap: wrap;
            .buttonPhones {
              order: 1;
              display: inline-flex;
              padding-right: 0.5rem;
              width: calc(100% - 3rem);
            }
            .appWidgetChat {
              order: 2;
              display: inline-flex;
              margin: 0;
              width: auto;
            }
            .paragraph {
              order: 3;
            }
          }
        }

        &-relevance {
          margin: 0 1.25rem;
          .value {
            flex-direction: column;
            &:last-of-type {
              align-items: flex-end;
            }
            span + span {
              padding-top: 0.375rem;
            }
            ._width-separator {
              margin-right: 0;
              padding-right: 0;
              border-right: none;
            }
          }
        }

        &-characteristics {
          margin: 1rem 1.25rem;
          .sellerPrivate {
            margin-bottom: 0;
          }
        }

        &-map {
          display: block;
          margin: 2rem -3.25rem 0;
          padding-left: 3.25rem;
          padding-right: 3.25rem;

          .buttonShowMap {
            font-size: 0.875rem;
          }
        }
      }

      @media screen and (max-width: 980px) {
        &-title {
          display: none;
        }

        &-slider {
          margin: 0 -1.25rem;

          .noPhoto {
            display: none;
          }

          .carousel {
            margin: 0 auto;
            width: 100vw;
            min-width: 20rem;
            max-width: 26rem;
          }

          .contractPart-image {
            display: block;
            width: 100%;
            height: 54vw;
            min-height: 12.5rem;
            max-height: 15rem;
            background-color: var(--bg-main);
            border:  1px solid var(--border-color-main);
          }
        }

        &-relevance {
          flex-direction: column;
          justify-content: flex-start;
          padding-bottom: 0.875rem;

          .value {
            padding-bottom: 0.375rem;
            width: 100%;
            font-size: 0.875rem;
            > span:first-of-type {
              margin-right: auto;
            }
          }
        }

        &-name {
          .sellerPrivate {
            display: inline-block;
            margin: 0.5rem auto 0 0;
          }
          .heading {
            padding: 1rem 0 0.625rem;
            font-size: 1.125rem;
            font-weight: var(--font-weight-medium);
          }
        }

        &-characteristics {
          margin: 0 -1.25rem;
          border-top: 1px solid var(--border-color-main);

          .sellerPrivate {
            display: none;
          }

          .boxFeature {
            width: 100%;

            &-title {
              display: none;
            }

            &-list {
              font-size: 0.875rem;

              &-item {
                border-bottom: 1px dashed var(--border-color-light);
              }

              &-name {
                border-bottom: none;

                > span {
                  margin-bottom: 0;
                  padding-bottom: 0;
                }
              }

              &-value {
                text-align: right;
                color: var(--color-main);
              }
            }
          }
        }

        &-seller-info-first {
          .sellerActions {
            display: flex;
            flex-wrap: wrap;
            justify-content: space-between;

            .paragraph {
              order: 2;
              padding: 0.75rem 0 1rem;
              width: 100%;
              text-align: center;
              color: var(--color-main-lightest);
            }

            & .buttonCallPrivateSeller,
            .buttonPhones {
              order: 1;
              width: calc(100% - 1rem - 3.75rem);
            }

            .appWidgetChat {
              order: 1;
            }
          }
        }

        &-seller-info-last {
          margin: 0 -1.25rem;

          .sellerBasic {
            position: relative;
            padding: 0;

            &-item {
              padding: 1.25rem;
              font-weight: var(--font-weight-regular);
              border-bottom: 1px solid var(--border-color-main);
            }

            .linkIsMobile {
              display: none;
              position: absolute;
              top: 0;
              left: 0;
              // display: flex;
              justify-content: flex-end;
              align-items: center;
              width: 100%;
              height: 100%;

              .svg {
                margin-right: 1.5rem;
                width: auto;
                height: .75rem;
                fill: var(--color-main-lightest);
              }
            }

            .buttonAsLink {
              font-size: inherit;
              font-weight: var(--font-weight-regular);
            }
          }

          .boxFeature {
            padding: 1.25rem;

            &-title {
              padding-bottom: 0.75rem;
              font-size: 1.125rem;
              font-weight: var(--font-weight-medium);
            }
          }

          .sclContacts {
            flex-wrap: wrap;
            &-item {
              margin-bottom: 1rem;
            }
          }

          .buttonReport {
            display: none;
          }
        }

        &-map {
          position: relative;
          margin: 0 -1.25rem;
          padding: 1.25rem;
          background-color: var(--bg-lightest);

          .sellerAddress {
            display: flex;
            align-items: center;
            &-title {
              display: none;
            }
            .value {
              padding-right: 1rem;
              color: var(--color-main-lightest);
            }
            .svg {
              margin-left: auto;
              margin-right: 0.25rem;
              width: auto;
              height: 0.75rem;
              fill: var(--color-main-lightest);
            }
          }

          .sellerMap {
            height: 0;
            opacity: 0;
            transition: opacity 0.2s var(--transition-easeOutQuad);
            &.-expanded {
              position: fixed;
              z-index: 999;
              top: 0;
              left: 0;
              width: 100vw;
              height: 100vh;
              opacity: 1;
            }

            .buttonBack {
              position: absolute;
              z-index: 1;
              top: 1rem;
              left: 1rem;
              display: block;
              width: 3.75rem;
              height: 3.75rem;
              font-size: 0;
              border: none;
              outline: none;
              border-radius: 50%;
              background-color: rgba(255,255,255,0.8);
              box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);
              .svg {
                fill: var(--color-main);
              }
            }
          }

          .buttonOutline {
            position: absolute;
            top: 0;
            left: 0;
            margin: 0;
            width: 100%;
            height: 100%;
            opacity: 0;
          }
        }

        &-description {
          margin: 0 -1.25rem;
        }

        &-report {
          .buttonReport {
            width: 100%;
          }
        }

        &-share {
          flex-wrap: wrap;
          align-items: flex-end;
        }

        &-buttons-order {
          padding-top: 2rem;
          .buttonsOrder {
            display: flex;
            justify-content: space-between;
            .button {
              width: calc(50% - 0.5rem);
              font-size: 1rem;
            }
          }
        }

        .accordion {
          &-panel {
            border-color: var(--border-color-main);
          }
          &-title {
            font-size: 1.125rem;
            font-weight: var(--font-weight-medium);
          }
          &-content {
            padding-bottom: 2rem;
          }
        }
      }
    }
  }
</style>
